﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Optimization;
using HeuristicLab.Data;
using HeuristicLab.Collections;
using HeuristicLab.Core;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Common.Resources;
using HeuristicLab.Common;

namespace HeuristicLab.OKB.AlgorithmHost {

  [Item("Problem Container", "Encapsulates problem & parameters for storing in the OKB")]  
  [StorableClass]
  public class ProblemContainer : ParameterizedNamedItemContainer {

    public ProblemContainer() { }
    [StorableConstructor]
    public ProblemContainer(bool deserializing) : base(deserializing) { }

    public IProblem Problem {
      get { return (IProblem)Item; }
      set { Item = value; }
    }

    public override Type ItemType { get { return typeof(IProblem); } }

    public override string ItemName { get { return "ProblemContainer"; } }
    public override string ItemDescription { get { return "Container for problems to be stored in the OKB"; } }

  }
}
